// This works :)

#define Version " Pico Si5351 T4 "

#include <Wire.h>
#include "LiquidCrystal_I2C.h"
#include "si5351.h"
Si5351 clockgen;                              // initalize clockgen

// SDA = 1
// SCL = 2
LiquidCrystal_I2C lcd(0x3f,16,2);  // set the LCD address to 0x30 maybe??

int x;
// unsigned long frequency;
double frequency1 =  1825000;          // 4 bytes required for frequency  Bodge to make it go until coils fixed
double frequency2 =  3630000;          // 4 bytes required for frequency
double frequency3 =  7000000;          // 4 bytes required for frequency
double frequency4 = 10100000;          // 4 bytes required for frequency
double frequency5 = 14100000;          // 4 bytes required for frequency
double frequency6 = 18068000;          // 4 bytes required for frequency
double frequency7 = 21000000;          // 4 bytes required for frequency
double frequency8 = 24000000;          // 4 bytes required for frequency
double frequency9 = 28000000;          // 4 bytes required for frequency
double frequency10= 52000000;          // 4 bytes required for frequency

#define Mixer2     4335300000       // Second mixer injection
#define LSB         164700000       // carrier mixer for LSB
  
void setup() { 
  clockgen.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);  
  pinMode(LED_BUILTIN,OUTPUT);
  lcd.init();                      // initialize the lcd 
  lcd.backlight();     
  lcd.print(Version);
  delay(1000);
  clockgen.set_freq(Mixer2,    SI5351_CLK1);
  clockgen.set_freq(LSB,       SI5351_CLK2);
}

/******************************
 main loop
*******************************/
void loop() { // excercise the LCD
  if (x==0)
  {clockgen.set_freq((frequency1*100), SI5351_CLK0);
   digitalWrite(LED_BUILTIN,HIGH);
   display_freq(frequency1);
  } 
  if (x==20)
  {clockgen.set_freq((frequency2*100), SI5351_CLK0);
    digitalWrite(LED_BUILTIN,LOW);
   display_freq(frequency2);
  }
  if (x==40)
  {clockgen.set_freq((frequency3*100), SI5351_CLK0);
   digitalWrite(LED_BUILTIN,HIGH);
   display_freq(frequency3);
  } 
  if (x==60)
  {clockgen.set_freq((frequency4*100), SI5351_CLK0);
    digitalWrite(LED_BUILTIN,LOW);
   display_freq(frequency4);
  }
    if (x==80)
  {clockgen.set_freq((frequency5*100), SI5351_CLK0);
   digitalWrite(LED_BUILTIN,HIGH);
   display_freq(frequency5);
  } 
  if (x==100)
  {clockgen.set_freq((frequency6*100), SI5351_CLK0);
    digitalWrite(LED_BUILTIN,LOW);
   display_freq(frequency6);
  }
    if (x==120)
  {clockgen.set_freq((frequency7*100), SI5351_CLK0);
   digitalWrite(LED_BUILTIN,HIGH);
   display_freq(frequency7);
  } 
  if (x==140)
  {clockgen.set_freq((frequency8*100), SI5351_CLK0);
    digitalWrite(LED_BUILTIN,LOW);
   display_freq(frequency8);
  }  
    if (x==160)
  {clockgen.set_freq((frequency9*100), SI5351_CLK0);
   digitalWrite(LED_BUILTIN,HIGH);
   display_freq(frequency9);
  } 
  if (x==180)
  {clockgen.set_freq((frequency10*100), SI5351_CLK0);
    digitalWrite(LED_BUILTIN,LOW);
   display_freq(frequency10);
  } 

  x ++;
  if(x>200
  )
  {x = 0;}
  delay(100);
}

 void display_freq(unsigned long frequency) {
  long MHz = frequency/1000000;
   
  // convert frequency to floating point
  // adding 0.0000001 fixes a rounding error
  double freq = (double) frequency/1000000+0.0000001;
  
    lcd.setCursor(2,1);                          // start at char 2, line 1
  if (MHz < 10) {
    lcd.print(" ");    
  } 
    lcd.print(freq, 6);
    lcd.print(" MHz ");

 }
